/*
Copyright (c) 2015 Red Hat, Inc.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package org.ovirt.engine.sdk4.builders;

import java.lang.String;
import org.ovirt.engine.sdk4.internal.containers.OpenStackImageContainer;
import org.ovirt.engine.sdk4.types.OpenStackImage;
import org.ovirt.engine.sdk4.types.OpenStackImageProvider;

public class OpenStackImageBuilder {
    private String comment;
    private String description;
    private String href;
    private String id;
    private String name;
    private OpenStackImageProvider openstackImageProvider;
    
    public OpenStackImageBuilder comment(String newComment) {
        comment = newComment;
        return this;
    }
    
    
    public OpenStackImageBuilder description(String newDescription) {
        description = newDescription;
        return this;
    }
    
    
    public OpenStackImageBuilder href(String newHref) {
        href = newHref;
        return this;
    }
    
    
    public OpenStackImageBuilder id(String newId) {
        id = newId;
        return this;
    }
    
    
    public OpenStackImageBuilder name(String newName) {
        name = newName;
        return this;
    }
    
    
    public OpenStackImageBuilder openstackImageProvider(OpenStackImageProvider newOpenstackImageProvider) {
        openstackImageProvider = newOpenstackImageProvider;
        return this;
    }
    
    public OpenStackImageBuilder openstackImageProvider(OpenStackImageProviderBuilder newOpenstackImageProvider) {
        if (newOpenstackImageProvider == null) {
            openstackImageProvider = null;
        }
        else {
            openstackImageProvider = newOpenstackImageProvider.build();
        }
        return this;
    }
    
    
    public OpenStackImage build() {
        OpenStackImageContainer container = new OpenStackImageContainer();
        container.comment(comment);
        container.description(description);
        container.href(href);
        container.id(id);
        container.name(name);
        container.openstackImageProvider(openstackImageProvider);
        return container;
    }
}
